
!BlockContext methodsFor: '*seaside-pharo-core' stamp: 'lr 4/19/2009 13:30'!
renderOn: aRenderer
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aRenderer ]! !

!Morph methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 15:50'!
seasideMimeDocument
	^ self imageForm seasideMimeDocument! !

!Morph methodsFor: '*seaside-pharo-core' stamp: 'pmm 6/19/2010 08:30'!
seasideMimeDocumentType: aMimeType
	^ self imageForm seasideMimeDocumentType: aMimeType! !

!BlockClosure methodsFor: '*seaside-pharo-core' stamp: 'lr 4/8/2009 13:32'!
renderOn: aRenderer
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aRenderer ]! !

!MIMEDocument methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 15:54'!
seasideMimeDocument
	^ WAMimeDocument on: self content mimeType: self contentType! !

!MIMEDocument methodsFor: '*seaside-pharo-core' stamp: 'lr 7/25/2011 19:52'!
seasideMimeDocumentType: aMimeType
	^ self seasideMimeDocument mimeType: aMimeType; yourself! !

!Object methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/19/2007 23:13'!
restoreFromSnapshot: anObject
	self copyFrom: anObject! !

!Object methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/15/2008 18:45'!
snapshotCopy
	^ self shallowCopy! !

!OrderedCollection methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 11/16/2007 17:11'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!OrderedCollection methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 1/3/2008 18:25'!
snapshotCopy
	^ self copy! !

!PositionableStream methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 15:53'!
seasideMimeDocument
	^ self contents seasideMimeDocument! !

!PositionableStream methodsFor: '*seaside-pharo-core' stamp: 'lr 7/25/2011 19:52'!
seasideMimeDocumentType: aMimetype
	^ self seasideMimeDocument
		mimeType: aMimetype;
		yourself! !

!Dictionary methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/31/2010 08:19'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Dictionary methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/31/2010 08:19'!
snapshotCopy
	^ self copy! !

!Set methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 1/3/2008 18:25'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Set methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 6/7/2007 22:14'!
snapshotCopy
	^ self copy! !

!WAUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 12/27/2010 12:16'!
basicNextPut: aCharacter
	self nextPut: aCharacter! !

!WAUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'rh 11/9/2011 15:20'!
basicNextPutAll: anObject
	self nextPutAll: anObject! !

!WAUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 12/27/2010 12:40'!
greaseNext: anInteger putAll: aCollection startingAt: startIndex
	| index |
	index := GRPlatform current indexOfFirstUnsafeUrlCharacterIn: aCollection startingAt: startIndex.
	(index = 0 or: [ index >= (startIndex + anInteger) ])
		ifTrue: [
			stream greaseNext: anInteger putAll: aCollection startingAt: startIndex ]
		ifFalse: [ self nextPutAll: (aCollection copyFrom: startIndex to: startIndex + anInteger - 1) ]! !

!WAUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 12/27/2010 12:15'!
isBinary
	^ false! !

!SmalltalkImage methodsFor: '*seaside-pharo-core' stamp: 'pmm 1/24/2011 07:20'!
initializeMemorySettingsProfileSeaside
        "Initialize the memory and GC settings to be more in line with Seaside requirements"
        
        "The following settings affect the rate incremental GCs and tenuring"
        
        "Limit incremental GC activity to run every 40k allocations"
        self vmParameterAt: 5 put: 100000. "allocations between GCs (default: 4000)"
        "Limit tenuring threshold to only tenure w/ > 35k survivors"
        self vmParameterAt: 6 put: 35000. "tenuring threshold (default: 2000)"
        
        "These settings affect overall memory usage"
        
        "Only give memory back to the OS when we have more than 16MB free"
        self vmParameterAt: 24 put: 16*1024*1024. "default 8MB"
        "Try to keep 8MB headroom at all times"
        self vmParameterAt: 25 put: 8*1024*1024. "default 4MB"
        
        "These settings describe what to do when we're close to running out of free space"
        
        "Tell the VM that we'd rather grow than spinning in tight GC loops"
        self setGCBiasToGrow: 1. "default: false"
        "Tell the VM to do a fullGC for good measure if the above growth exceeded 16MB"
        self setGCBiasToGrowGCLimit: 16*1024*1024. "default: 0"! !

!MessageSend methodsFor: '*seaside-pharo-core' stamp: 'lr 8/4/2006 09:18'!
renderOn: html
	self value: html! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'jf 9/22/2008 13:21'!
defaultMimeType
	^ WAMimeType imageGif! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'mb 6/12/2006 14:01'!
mimeType
	^ self defaultMimeType! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 16:39'!
seasideMimeDocument
	^ self seasideMimeDocumentType: self defaultMimeType! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'pmm 6/19/2010 08:30'!
seasideMimeDocumentType: aMimeType
	"Converts the receiver to a WAMimeDocument. The argument should ideally be an instance for WAMimeType. For various crappy reasons Strings and nil are also allowed."
	
	| aStream writer |
	aStream := RWBinaryOrTextStream on: String new.
	writer := self writerForMimeType: aMimeType seasideMimeType.
	writer isNil ifTrue: [ self error: 'no writer for ', aMimeType greaseString, ' found' ].
	writer putForm: (self asFormOfDepth: 32) onStream: aStream.
	^ WAMimeDocument on: aStream contents mimeType: aMimeType! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'NickAger 4/1/2012 11:03'!
writerForMimeType: mimeType
	| sub |
	mimeType main ~= 'image'
		ifTrue: [ ^ nil ]. 
	"First token is assumed to be 'image'"
	sub := mimeType sub.
	(sub = 'jpg' or: [ sub = 'jpeg' ])
		ifTrue: [ ^ Smalltalk at: #JPEGReadWriter2 ifAbsent: [ Smalltalk at: #PluginBasedJPEGReadWriter ifAbsent: [ nil ] ] ].
	sub = 'png' ifTrue: [ ^ PNGReadWriter ].
	sub = 'bmp' ifTrue: [ ^ BMPReadWriter ].
	sub = 'gif' ifTrue: [ ^ GIFReadWriter ].
	^ nil! !

!Bag methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 1/3/2008 18:25'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Bag methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 4/20/2007 20:43'!
snapshotCopy
	^ self copy! !

!GRPackage class methodsFor: '*seaside-pharo-core' stamp: 'lr 2/17/2010 15:12'!
seasidePharoCore
	^ self new
		name: 'Seaside-Pharo-Core';
		addDependency: 'Seaside-Core';
		addDependency: 'Grease-Pharo-Core';
		url: #seasideUrl;
		yourself! !
